{{ *****************************
'' GPS routines
''  (c) 2007 Perry James Mole
''  pjm@ridge-communications.ca
'' *****************************

' PVH Comment - Excellent small GPS reader routines.
' $GPRMC  Recommended minimum data                 ie: $GPRMC,081836,A,3751.6565,S,14507.3654,E,000.0,360.0,130998,011.3,E*62
' $GPGGA  GPS Fix Data                             ie: $GPGGA,170834,4124.8963,N,08151.6838,W,1,05,1.5,280.2,M,-34.0,M,,,*75
' $PGRMZ  eTrex proprietary barametric altitude ft ie: $PGRMZ,453,f,2*18

$IIRMC,110857,A,5217.977,N,00515.917,E,00.0,284,150112,00,E,A*08
          0   1    2     3     4     5  6    7     8    9 10 11
$IIVWR,079,R,00.0,N,,,,*6F
         0 1  2   3     4
$IIGLL,5217.977,N,00515.917,E,110857,A,A*5C
          0     1     2     3    4   5  6
$IIMWV,079,R,03.6,N,A*18
         0 1  2   3  4
$IIMWV,079,T,04.2,N,A*1D
         0 1  2   3  4  
RMC, hhmmss,A(Valid),Latitude,N(orth),Longitude,E(ast),0.00(Speedknots), 327(CourseDegreesTrue),(Date),00(MagneticVariation),E(ast),A*08(Checksum)
$IIMWV,079(degrees),R(elative),4.2, N(autical Miles), A (Valid)*1D(checksum)

}}
CON

  CR = 13                                               ' ASCII <CR>
  LF = 10                                               ' ASCII <LF>
  serXmit   = 0                                         ' Serial Transmit on mouse
  serRecv   = 7                                         ' Serial Receive  on mouse EH:1=>7. Signal tacktick! =)
  
VAR  
   long gps_stack[10] 
   byte GPRMCb[68],MWVb[40],VWRb[40],GPGGLb[80],PGRMZb[40]        'EH: added MWVb[40],VWRb[40]
   long GPRMCa[20],MWVa[20],VWRa[20],GPGGLa[20],PGRMZa[20]        'EH: added MWVb[20],VWRb[20]


   byte gps_buff[80],Rx',cksum
   long cog,cptr,ptr,arg,j
   long Null[1]
   
OBJ
  uart :  "FullDuplexSerial_mini"

PUB start : okay

'' Starts uart object (at baud specified) in a cog
'' -- returns false if no cog available

  okay := uart.start(serRecv,serXmit,1,4800)
  return cog := cognew(readNEMA,@gps_stack) + 1 

PUB readNEMA
  Null[0] := 0
  repeat
   longfill(gps_buff,20,0)      
   repeat while Rx <>= "$"      ' wait for the $ to insure we are starting with
     Rx := uart.rx              '   a complete NMEA sentence 
   cptr := 0

   repeat while Rx <>= CR       '  continue to collect data until the end of the NMEA sentence 
     Rx := uart.rx              '  get character from Rx Buffer
     if Rx == ","
       gps_buff[cptr++] := 0    '  If "," replace the character with 0
     else
       gps_buff[cptr++] := Rx   '  else save the character   

   if gps_buff[2] == "M"         'EH: added MWV routine    
     if gps_buff[3] == "W"            
       if gps_buff[4] == "V"            
           copy_buffer(@MWVb, @MWVa)

   if gps_buff[2] == "V"         'EH: added VWR routine    
     if gps_buff[3] == "W"            
       if gps_buff[4] == "R"
           copy_buffer(@VWRb, @VWRa)

   if gps_buff[2] == "R"             
     if gps_buff[3] == "M"            
       if gps_buff[4] == "C"           
           copy_buffer(@GPRMCb, @GPRMCa)

   if gps_buff[2] == "G"             
     if gps_buff[3] == "L"                'EH: G => L 
       if gps_buff[4] == "L"              'EH: G => L
           copy_buffer(@GPGGLb, @GPGGLa)

   {{if gps_buff[0] == "P"
    if gps_buff[1] == "G"  
     if gps_buff[2] == "R"
      if gps_buff[3] == "M"  
       if gps_buff[4] == "Z"
           copy_buffer(@PGRMZb, @PGRMZa) }}
                
pub copy_buffer ( buffer,args)
         bytemove(buffer,@gps_buff,cptr) '  copy received data to buffer
         ptr := buffer
         arg := 0
         repeat j from 0 to 78           ' build array of pointers
          if byte[ptr] == 0               ' to each
             if byte[ptr+1] == 0           ' record
                long[args][arg] := Null     ' in 
             else                            ' the
                long[args][arg] := ptr+1     ' data buffer
             arg++
          ptr++
          
' now we just need to return the pointer to the desired record
'$IIVWR,088,R,02.5,N,,,,*66
'        0 1  2   3     4
pub AWA
   return VWRa[0]

pub LR
   return VWRa[1]

pub AWS
   return VWRa[2]

'$IIRMC,110857,A,5217.977,N,00515.917,E,00.0,284,150112,00,E,A*08
'          0   1    2     3     4     5   6    7     8   9 10 11
'         time val  Lat   North Lon  East BS     date  var E Chcksum
pub time
   return GPGGLa[4]

pub valid
   return GPRMCa[1]
      
pub latitude
   return GPRMCa[2]
    
pub N_S
   return GPRMCa[3]
     
pub longitude
   return GPRMCa[4]
    
pub E_W
   return GPRMCa[5]

pub speed
   return GPRMCa[6]

pub heading
   return GPRMCa[7]
   
pub date
   return GPRMCa[8]
    
'pub GPSaltitude
'   return GPGGAa[8]

'pub satellites
'   return GPGGAa[6]
    
'pub hdop
'   return GPGGAa[7]

'pub altitude
'   return PGRMZa[0]

'pub vdop
'   return GPGSAa[14] 